# -*- coding: utf-8 -*-
from trac.core import *
from trac.Search import ISearchSource, query_to_sql, shorten_result
from trac import util

class DiscussionSearch(Component):
    implements(ISearchSource)

    def get_search_filters(self, req):
        if req.perm.has_permission('DISCUSSION_VIEW'):
            yield ("discussion", "Discussion")

    def get_search_results(self, req, query, filters):
        if not 'discussion' in filters:
            return
        result = []
        db = self.env.get_db_cnx()
        cursor = db.cursor()
        sql = "SELECT * FROM topic WHERE subject||body LIKE '%%%s%%'" % query
        cursor.execute(sql)
        for id,forum,time,author,subject,body in cursor:
            x = (self.env.href.discussion(forum, id),
                    "topic:%d: %s" % (id, util.shorten_line(subject)),
                    time, author,
                    shorten_result(body, query.split()))
            result.append(x)
        sql = "SELECT m.*, t.subject FROM message AS m, topic AS t "\
                "WHERE m.topic=t.id AND m.body LIKE '%%%s%%'" % query
        cursor.execute(sql)
        for id,forum,topic,replyto,time,author,body,subject in cursor:
            x = (self.env.href.discussion(forum, topic, id),
                    "message:%d: %s" % (id, util.shorten_line(subject)),
                    time, author,
                    shorten_result(body, query.split()))
            result.append(x)
        return result
